msysGit-based Git for Windows 1.x was superseded by Git for Windows 2.x
[git/mingw/4msysgit.git] / git-sh-setup.sh
blob5adc011efe56ea2320823e6e04c7883049c9cbad
1 # This shell scriplet is meant to be included by other shell scripts
2 # to set up some variables pointing at the normal git directories and
3 # a few helper shell functions.
5 # Having this variable in your environment would break scripts because
6 # you would cause "cd" to be taken to unexpected places. If you
7 # like CDPATH, define it for your interactive shell sessions without
8 # exporting it.
9 # But we protect ourselves from such a user mistake nevertheless.
10 unset CDPATH
12 # Similarly for IFS, but some shells (e.g. FreeBSD 7.2) are buggy and
13 # do not equate an unset IFS with IFS with the default, so here is
14 # an explicit SP HT LF.
15 IFS='
18 git_broken_path_fix () {
19 case ":$PATH:" in
20 *:$1:*) : ok ;;
22 PATH=$(
23 SANE_TOOL_PATH="$1"
24 IFS=: path= sep=
25 set x $PATH
26 shift
27 for elem
29 case "$SANE_TOOL_PATH:$elem" in
30 (?*:/bin | ?*:/usr/bin)
31 path="$path$sep$SANE_TOOL_PATH"
32 sep=:
33 SANE_TOOL_PATH=
34 esac
35 path="$path$sep$elem"
36 sep=:
37 done
38 echo "$path"
41 esac
44 # @@BROKEN_PATH_FIX@@
46 die () {
47 die_with_status 1 "$@"
50 die_with_status () {
51 status=$1
52 shift
53 printf >&2 '%s\n' "$*"
54 exit "$status"
57 GIT_QUIET=
59 say () {
60 if test -z "$GIT_QUIET"
61 then
62 cat <<EOF
64 EOF
68 if test -n "$OPTIONS_SPEC"; then
69 usage() {
70 "$0" -h
71 exit 1
74 parseopt_extra=
75 [ -n "$OPTIONS_KEEPDASHDASH" ] &&
76 parseopt_extra="--keep-dashdash"
77 [ -n "$OPTIONS_STUCKLONG" ] &&
78 parseopt_extra="$parseopt_extra --stuck-long"
80 eval "$(
81 echo "$OPTIONS_SPEC" |
82 git rev-parse --parseopt $parseopt_extra -- "$@" ||
83 echo exit $?
85 else
86 dashless=$(basename "$0" | sed -e 's/-/ /')
87 usage() {
88 die "usage: $dashless $USAGE"
91 if [ -z "$LONG_USAGE" ]
92 then
93 LONG_USAGE="usage: $dashless $USAGE"
94 else
95 LONG_USAGE="usage: $dashless $USAGE
97 $LONG_USAGE"
100 case "$1" in
102 echo "$LONG_USAGE"
103 exit
104 esac
107 # Set the name of the end-user facing command in the reflog when the
108 # script may update refs. When GIT_REFLOG_ACTION is already set, this
109 # will not overwrite it, so that a scripted Porcelain (e.g. "git
110 # rebase") can set it to its own name (e.g. "rebase") and then call
111 # another scripted Porcelain (e.g. "git am") and a call to this
112 # function in the latter will keep the name of the end-user facing
113 # program (e.g. "rebase") in GIT_REFLOG_ACTION, ensuring whatever it
114 # does will be record as actions done as part of the end-user facing
115 # operation (e.g. "rebase").
117 # NOTE NOTE NOTE: consequently, after assigning a specific message to
118 # GIT_REFLOG_ACTION when calling a "git" command to record a custom
119 # reflog message, do not leave that custom value in GIT_REFLOG_ACTION,
120 # after you are done. Other callers of "git" commands that rely on
121 # writing the default "program name" in reflog expect the variable to
122 # contain the value set by this function.
124 # To use a custom reflog message, do either one of these three:
126 # (a) use a single-shot export form:
127 # GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: preparing frotz" \
128 # git command-that-updates-a-ref
130 # (b) save the original away and restore:
131 # SAVED_ACTION=$GIT_REFLOG_ACTION
132 # GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: preparing frotz"
133 # git command-that-updates-a-ref
134 # GIT_REFLOG_ACITON=$SAVED_ACTION
136 # (c) assign the variable in a subshell:
138 # GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: preparing frotz"
139 # git command-that-updates-a-ref
141 set_reflog_action() {
142 if [ -z "${GIT_REFLOG_ACTION:+set}" ]
143 then
144 GIT_REFLOG_ACTION="$*"
145 export GIT_REFLOG_ACTION
149 git_editor() {
150 if test -z "${GIT_EDITOR:+set}"
151 then
152 GIT_EDITOR="$(git var GIT_EDITOR)" || return $?
155 eval "$GIT_EDITOR" '"$@"'
158 git_pager() {
159 if test -t 1
160 then
161 GIT_PAGER=$(git var GIT_PAGER)
162 else
163 GIT_PAGER=cat
165 : ${LESS=-FRX}
166 : ${LV=-c}
167 export LESS LV
169 eval "$GIT_PAGER" '"$@"'
172 sane_grep () {
173 GREP_OPTIONS= LC_ALL=C grep "$@"
176 sane_egrep () {
177 GREP_OPTIONS= LC_ALL=C egrep "$@"
180 is_bare_repository () {
181 git rev-parse --is-bare-repository
184 cd_to_toplevel () {
185 cdup=$(git rev-parse --show-toplevel) &&
186 cd "$cdup" || {
187 echo >&2 "Cannot chdir to $cdup, the toplevel of the working tree"
188 exit 1
192 require_work_tree_exists () {
193 if test "z$(git rev-parse --is-bare-repository)" != zfalse
194 then
195 die "fatal: $0 cannot be used without a working tree."
199 require_work_tree () {
200 test "$(git rev-parse --is-inside-work-tree 2>/dev/null)" = true ||
201 die "fatal: $0 cannot be used without a working tree."
204 require_clean_work_tree () {
205 git rev-parse --verify HEAD >/dev/null || exit 1
206 git update-index -q --ignore-submodules --refresh
207 err=0
209 if ! git diff-files --quiet --ignore-submodules
210 then
211 echo >&2 "Cannot $1: You have unstaged changes."
212 err=1
215 if ! git diff-index --cached --quiet --ignore-submodules HEAD --
216 then
217 if [ $err = 0 ]
218 then
219 echo >&2 "Cannot $1: Your index contains uncommitted changes."
220 else
221 echo >&2 "Additionally, your index contains uncommitted changes."
223 err=1
226 if [ $err = 1 ]
227 then
228 test -n "$2" && echo >&2 "$2"
229 exit 1
233 # Generate a sed script to parse identities from a commit.
235 # Reads the commit from stdin, which should be in raw format (e.g., from
236 # cat-file or "--pretty=raw").
238 # The first argument specifies the ident line to parse (e.g., "author"), and
239 # the second specifies the environment variable to put it in (e.g., "AUTHOR"
240 # for "GIT_AUTHOR_*"). Multiple pairs can be given to parse author and
241 # committer.
242 pick_ident_script () {
243 while test $# -gt 0
245 lid=$1; shift
246 uid=$1; shift
247 printf '%s' "
248 /^$lid /{
249 s/'/'\\\\''/g
251 s/^$lid "'\([^<]*\) <[^>]*> .*$/\1/'"
252 s/.*/GIT_${uid}_NAME='&'/p
255 s/^$lid "'[^<]* <\([^>]*\)> .*$/\1/'"
256 s/.*/GIT_${uid}_EMAIL='&'/p
259 s/^$lid "'[^<]* <[^>]*> \(.*\)$/@\1/'"
260 s/.*/GIT_${uid}_DATE='&'/p
263 done
264 echo '/^$/q'
267 # Create a pick-script as above and feed it to sed. Stdout is suitable for
268 # feeding to eval.
269 parse_ident_from_commit () {
270 LANG=C LC_ALL=C sed -ne "$(pick_ident_script "$@")"
273 # Parse the author from a commit given as an argument. Stdout is suitable for
274 # feeding to eval to set the usual GIT_* ident variables.
275 get_author_ident_from_commit () {
276 encoding=$(git config i18n.commitencoding || echo UTF-8)
277 git show -s --pretty=raw --encoding="$encoding" "$1" -- |
278 parse_ident_from_commit author AUTHOR
281 # Clear repo-local GIT_* environment variables. Useful when switching to
282 # another repository (e.g. when entering a submodule). See also the env
283 # list in git_connect()
284 clear_local_git_env() {
285 unset $(git rev-parse --local-env-vars)
288 # Generate a virtual base file for a two-file merge. Uses git apply to
289 # remove lines from $1 that are not in $2, leaving only common lines.
290 create_virtual_base() {
291 sz0=$(wc -c <"$1")
292 @@DIFF@@ -u -La/"$1" -Lb/"$1" "$1" "$2" | git apply --no-add
293 sz1=$(wc -c <"$1")
295 # If we do not have enough common material, it is not
296 # worth trying two-file merge using common subsections.
297 expr $sz0 \< $sz1 \* 2 >/dev/null || : >"$1"
301 # Platform specific tweaks to work around some commands
302 case $(uname -s) in
303 *MINGW*)
304 # Windows has its own (incompatible) sort and find
305 sort () {
306 /usr/bin/sort "$@"
308 find () {
309 /usr/bin/find "$@"
311 # git sees Windows-style pwd
312 pwd () {
313 builtin pwd -W
315 is_absolute_path () {
316 case "$1" in
317 [/\\]* | [A-Za-z]:*)
318 return 0 ;;
319 esac
320 return 1
324 is_absolute_path () {
325 case "$1" in
327 return 0 ;;
328 esac
329 return 1
331 esac
333 # Make sure we are in a valid repository of a vintage we understand,
334 # if we require to be in a git repository.
335 if test -z "$NONGIT_OK"
336 then
337 GIT_DIR=$(git rev-parse --git-dir) || exit
338 if [ -z "$SUBDIRECTORY_OK" ]
339 then
340 test -z "$(git rev-parse --show-cdup)" || {
341 exit=$?
342 echo >&2 "You need to run this command from the toplevel of the working tree."
343 exit $exit
346 test -n "$GIT_DIR" && GIT_DIR=$(cd "$GIT_DIR" && pwd) || {
347 echo >&2 "Unable to determine absolute path of git directory"
348 exit 1
350 : ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"}
353 peel_committish () {
354 case "$1" in
355 :/*)
356 peeltmp=$(git rev-parse --verify "$1") &&
357 git rev-parse --verify "${peeltmp}^0"
360 git rev-parse --verify "${1}^0"
362 esac